Package com.oracle.truffle.object.basic

## Class BasicLocations.IntLocationDecorator

- java.lang.Object
- - com.oracle.truffle.api.object.Location
  - - com.oracle.truffle.object.LocationImpl
    - - com.oracle.truffle.object.basic.BasicLocations.PrimitiveLocationDecorator
      - - com.oracle.truffle.object.basic.BasicLocations.IntLocationDecorator

All Implemented Interfaces:
  `BaseLocation`, `IntLocation`, `TypedLocation`

Enclosing class:
  BasicLocations

    public static class BasicLocations.IntLocationDecorator
    extends BasicLocations.PrimitiveLocationDecorator
    implements IntLocation

### Nested Class Summary

### Nested classes/interfaces inherited from class com.oracle.truffle.object.LocationImpl

`LocationImpl.EffectivelyFinalLocation<T extends Location>, LocationImpl.InternalLongLocation, LocationImpl.TypedObjectLocation<T extends Location & ObjectLocation>`

### Constructor Summary

Constructors
`IntLocationDecorator​(LocationImpl.InternalLongLocation longLocation)`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `canStore​(java.lang.Object value)` Returns `true` if the location is compatible with the value.
`java.lang.Object` `get​(DynamicObject store, boolean condition)` Get object value as object at this location in store.
`int` `getInt​(DynamicObject store, boolean condition)`
`int` `getInt​(DynamicObject store, Shape shape)`
`java.lang.Class<java.lang.Integer>` `getType()` The type of this location.
`void` `setInt​(DynamicObject store, int value)`
`void` `setInt​(DynamicObject store, int value, Shape shape)`
`void` `setInt​(DynamicObject store, int value, Shape oldShape, Shape newShape)`
`void` `setInternal​(DynamicObject store, java.lang.Object value)` Like `Location.set(DynamicObject, Object, Shape)`, but does not invalidate final locations.

### Methods inherited from class com.oracle.truffle.object.basic.BasicLocations.PrimitiveLocationDecorator

`getLong, getLong, primitiveArrayCount, primitiveFieldCount, setLong, setLong, setLongInternal`

### Methods inherited from class com.oracle.truffle.object.LocationImpl

`canSet, canStoreFinal, equals, getInternal, getWhereString, hashCode, isConstant, isFinal, objectArrayCount, objectFieldCount, set, toString, valueEquals`

### Methods inherited from class com.oracle.truffle.api.object.Location

`checkShape, finalLocation, get, incompatibleLocation, set, set`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.oracle.truffle.api.object.BaseLocation

`get, set, set, set`

### Constructor Detail

#### IntLocationDecorator

    public IntLocationDecorator​(LocationImpl.InternalLongLocation longLocation)

### Method Detail

#### get

    public final java.lang.Object get​(DynamicObject store,
                                      boolean condition)

Description copied from interface: `BaseLocation`
Get object value as object at this location in store. For internal use only and subject to change, use `BaseLocation.get(DynamicObject, Shape)` instead.

Specified by:
  `get` in interface `BaseLocation`
Overrides:
  `get` in class `Location`
  `condition` - the result of a shape check or `false`
See Also:
  `BaseLocation.get(DynamicObject, Shape)`

#### getInt

    public int getInt​(DynamicObject store,
                      boolean condition)

Specified by:
  `getInt` in interface `IntLocation`
See Also:
  `BaseLocation.get(DynamicObject, boolean)`

#### setInt

    public void setInt​(DynamicObject store,
                       int value,
                       Shape shape)
                throws FinalLocationException

Specified by:
  `setInt` in interface `IntLocation`
Throws:
  `FinalLocationException`
See Also:
  `BaseLocation.set(DynamicObject, Object, Shape)`

#### setInt

    public final void setInt​(DynamicObject store,
                             int value)
                      throws FinalLocationException

Specified by:
  `setInt` in interface `IntLocation`
Throws:
  `FinalLocationException`
See Also:
  `BaseLocation.set(DynamicObject, Object)`

#### setInternal

    public final void setInternal​(DynamicObject store,
                                  java.lang.Object value)
                           throws IncompatibleLocationException

Description copied from class: `Location`
Like `Location.set(DynamicObject, Object, Shape)`, but does not invalidate final locations. For internal use only and subject to change, use `DynamicObjectFactory` to create objects with predefined properties.

Specified by:
  `setInternal` in class `LocationImpl`
Throws:
  `IncompatibleLocationException` - if value is of non-assignable type

#### getInt

    public final int getInt​(DynamicObject store,
                            Shape shape)

Specified by:
  `getInt` in interface `IntLocation`
See Also:
  `BaseLocation.get(DynamicObject, Shape)`

#### canStore

    public final boolean canStore​(java.lang.Object value)

Description copied from class: `Location`
Returns `true` if the location is compatible with the value. The value may still be rejected if `Location.canSet(DynamicObject, Object)` returns false.

Overrides:
  `canStore` in class `LocationImpl`
Parameters:
  `value` - the value in question

#### setInt

    public final void setInt​(DynamicObject store,
                             int value,
                             Shape oldShape,
                             Shape newShape)

Specified by:
  `setInt` in interface `IntLocation`
See Also:
  `BaseLocation.set(DynamicObject, Object, Shape, Shape)`

#### getType

    public java.lang.Class<java.lang.Integer> getType()

Description copied from interface: `TypedLocation`
The type of this location.

Specified by:
  `getType` in interface `IntLocation`
Specified by:
  `getType` in interface `TypedLocation`